<script lang="ts">
  import CardBack from "./CardBack.svelte";
  import CardFront from "./CardFront.svelte";
  import { send, receive } from "./crossfade";

  import { createEventDispatcher } from "svelte";
  const dispatch = createEventDispatcher();

  const angleStep = 6;

  export let cards: Card[];
  export let clickable: (c: Card) => boolean = (_) => false;
  export let active: boolean = false;
  export let facedown: boolean = false;

  function getCardStyle(size: number, idx: number): string {
    const startAngle = (1 - size) * (angleStep / 2);
    const angle = startAngle + idx * angleStep;
    return `
      --card-rotation: ${angle.toFixed(2)}deg;
    `;
  }
</script>

<ul class="fan">
  {#each cards as card, idx (card)}
    <li style={getCardStyle(cards.length, idx)}>
      <button
        class:active={active && !facedown}
        disabled={facedown || !active || !clickable(card)}
        on:click={() => dispatch("click", { card, idx })}
      >
        <div in:receive={{ key: card }} out:send={{ key: card }}>
          {#if facedown}
            <CardBack />
          {:else}
            <CardFront {card} />
          {/if}
        </div>
      </button>
    </li>
  {/each}
</ul>

<style>
  ul {
    position: relative;
  }

  li {
    position: absolute;

    transform-origin: center 200%;
    transition: transform 0.5s;
    transform: rotate(var(--card-rotation));
  }
  button {
    width: 100%;
    transition: transform 0.25s;

    text-align: inherit;
    line-height: inherit;
    font-size: inherit;
    background-color: inherit;
    border: 0;
    padding: 0;
    cursor: pointer;
  }
  button:disabled {
    cursor: inherit;
    color: inherit;
  }
  button.active:disabled {
    cursor: not-allowed;
  }

  button:not(:disabled):hover,
  button:not(:disabled):focus {
    transform: translateY(-20%);
  }
</style>
